// StreamListener... for fetching http stuff
// You must pass a parser when constructing the StreamListener.
// That object's parse method will be invoked when all the data
// has arrived.
//
// $Id: class_StreamListener.js,v 1.3 2004/01/27 17:03:48 burgner Exp $

function StreamListener(parser)
{
    this.data = "";
    //this.url = url;
    //this.observer = observer;
    this.started = false;
    this.completed = false;
    this.parser = parser;
}

StreamListener.prototype.onStartRequest =
 function (request, context)
{
    //window.alert('Request started');
    this.started = true;
}

StreamListener.prototype.onStopRequest =
function (request, context, status)
{
    //    window.alert('OnStopRequest: status: ' + status);
    this.completed = true;
    this.parser.parse(this.data);
}

const SIS_CTRID       = "@mozilla.org/scriptableinputstream;1"
const nsIScriptableInputStream = Components.interfaces.nsIScriptableInputStream;

StreamListener.prototype.onDataAvailable =
function (request, context, inStr, sourceOffset, count)
{
    //    window.alert('OnDataAvailable():' + count);
    // sometimes the inStr changes between onDataAvailable calls, so we
    // can't cache it.
    var sis = 
        Components.classes[SIS_CTRID].createInstance(nsIScriptableInputStream);
    sis.init(inStr);
    this.data += sis.read(count);
}
